#include "widget.h"
#include "ui_widget.h"
#include <QDebug>
#include <QFileDialog>
#include <QMessageBox>
#include <vector>
using namespace std;

#define SSLCONNEXION2SMTP

//______________________________________________________ constructeur
Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    ui->setupUi(this);
    // First create the SmtpClient object and set the user and the password.
#ifdef SSLCONNEXION2SMTP
    // exemple pour gmail
    smtp = new SmtpClient("smtp.gmail.com", 465, SmtpClient::SslConnection);        // ssl connexion
    myEmailAddress = "your-email@gmail.com";
    smtp->setUser("your-email@gmail.com");
    smtp->setPassword("your-paswd-for-gmail");
#else
    smtp = new SmtpClient("your-SMTP-server", 25, SmtpClient::TcpConnection);        // not ssl connexion

#endif

    // la pièce jointe
    fileName.clear();
}

Widget::~Widget()
{
    delete ui;
    if (smtp) delete smtp;
}


// _____________________________________________________ ajout de pièce jointe
void Widget::on_pushButtonPJ_clicked()
{
    fileName = QFileDialog::getOpenFileName(this, "Joindre", "./");
}

//_____________________________________________________ Envoyer le mail
void Widget::on_pushButtonSend_clicked()
{
    // Create a MimeMessage
    MimeMessage message;
    message.setSender(new EmailAddress(myEmailAddress,"Moi"));
    message.addRecipient(new EmailAddress(ui->lineEditdestinataire->text(),"Lui"));
    // message.addRecipient(new EmailAddress(..., ...));    // autant que l'on veut
    message.setSubject("Un petit exemple d'envoi d'emails");


    // Add some text
    MimeText text;
    text.setText(ui->textEdit->toPlainText());  // le corps du message
    message.addPart(&text);

    // Now we create the attachment obMimeAttachment att(new QFile());
    if (!fileName.isEmpty()){
        ////// Add  attachment
        message.addPart(new MimeAttachment(new QFile(fileName)));
        }


    // Now we can send the mail
    smtp->connectToHost();

#ifdef SSLCONNEXION2SMTP
    smtp->login();
#endif

    bool mailOk = smtp->sendMail(message);
    smtp->quit();
    QMessageBox::information(this, "Envoi email", (mailOk ?  "message envoyé" : "erreur"));
}
